#=========================================================
# CopyVertexGroups.py
#
# Blender2.42.4
# Python Release 2.4.3 29 March 2006
#
# ȒPȐ
#   _O[v _Src  _Dest ɂ钸_WҏWXNvgłB
#   ܂g΍EΏ̃~[݂ȂƂo܂B
#   rvk1_torvk2.py ̂P̃IuWFNgŕҏWo[W݂Ȃ̂łB
#
#   ȊEEE
#   _Src  (  10 , 20 , 30 ) ƌ_Ƃ -X Y Z Ŏs
#   _Dest ( -10 , 20 , 30 ) ɂȂ܂B
#
#   X , Y , Z ̃{^̓gOɂȂă}CiXƃvXɐ؂ւ܂B
#   ׂ̍ɂ鏬ȃ{^ŗLE؂ւ܂B
#   ɂƂ͖̎܂B
#
#   Execute   : s܂B
#   Direction : Normal / Reverse    _HłB
#   Execute   : Normal / RealTime   RealTime ɐݒ肷 X , Y , Z łf܂B
#   ShapeKey  : None / Add / Ask    VFCvL[ɑ΂铮łB
#   Src >>    : _ɂȂ钸_O[v͂Ďw肵܂B
#   Dest>>    : ҏW钸_O[v͂Ďw肵܂B
#               Ẽ{^ƑIꂽ|CgO[v̌⃊XgôłIׂ܂B
#   Exit      : I܂B
#
# g
#   1 IuWFNgI܂B
#   2 ̃IuWFNg Vertex Groups  _Src  _Dest ݒ肵܂B
#   3 ̃XNvgs܂B
#     _Src  _Dest ̒_ҏW܂B
#
# Auther: keina
#
# See Also:
#   .blender/scripts/rvk1_torvk2.py
#   http://www.geocities.co.jp/SiliconValley-Cupertino/2019/blender/PythonDocJpn/index.html
#   http://pleac.sourceforge.net/pleac_python/index.html
#   http://blenderartists.org/ http://blenderartists.org/forum/
#   http://www.python.org/  http://www.python.org/doc/
#
# History:
#   2007.02.05(Mon)   \̒_\Ă܂C܂B
#   2006.06.29(Thu)b  |bvAbvj[\̍ۂɒ_O[vɊYȂ̃bZ[WC
#                     Event_Reverse ̍ۂ Event_RealTime 𔽉flɏC
#                     Vertex ̃x Direction ɕύX
#   2006.06.29(Thu)   _Src , _Dest ȊOłolɂ܂B
#   2006.06.28(Wed)   Created
#
# CopyRight(c) 2006 K.Keina
# Mail: keines@ps.sakura.ne.jp
# Web : http://keines.gozaru.jp/blender/
#=========================================================

print '--- CopyVertexGroups.py ---'
import Blender
from Blender import Draw, BGL, Object

# Other variables
Title		= 'Copy Vertex Groups : _Src to _Dest'
Version		= 'ver.2007.02.05(Mon) 00:18'
Author		= ' by keines'
VerWidth	= Draw.GetStringWidth(Version+Author)
MainWidth	= VerWidth+Draw.GetStringWidth(Title)

# + Cxgԍ
Event_Menu	= 0
Event_Enable	= 1
Event_XYZ	= 2
Event_Reverse	= 3
Event_RealTime	= 4
Event_Name	= 5
Event_Execute	= 6
Event_MenuSrc	= 7
Event_MenuDest	= 8
Event_Exit	= 9

# + VFCvL[̒ǉj[
ShapeMenuStr = "ShapeKey Menu %t|None %x1|Add %x2|Ask%x3"
ShapeMenu=Draw.Create(1)


# + `悷邽߂̊{l
SpcWidth	= 20
BaseHeight	= 20
BtnHeight	= 20
SplitStr	= '--------------------------------------------'
DirectionValue	= [[' ',1],['-',-1]]
DevelopLabel	= ['Normal','Reverse','RealTime','Direction','Execute','ShapeKey']
DevelopLabel_Vertex= 3
DevelopLabel_Execute=4
DevelopLabel_ShapeKey=5

# + X , Y , Z , Vertex , RealTime , Execute ,Exit
EnableBtnList=[Draw.Create(0),Draw.Create(0),Draw.Create(0)]
EnableBtnStr=['-','+']

BtnList=[[Draw.Create(1),'X ',0],[Draw.Create(0),'Y ',0],[Draw.Create(0),'Z ',0],[Draw.Create(0),DevelopLabel[DevelopLabel_Vertex],0],[Draw.Create(0),'RealTime',0],[0,DevelopLabel[DevelopLabel_Execute],0],[0,'Exit',0]]
BtnList_X	= 0 # EnableBtn Ɠ
BtnList_Y	= 1 #
BtnList_Z	= 2 #
BtnList_Reverse	= 3
BtnList_RealTime= 4
BtnList_Execute	= 5
BtnList_Exit	= 6
for i in range(len(BtnList)):
    BtnList[i][2]=Draw.GetStringWidth(BtnList[i][1])+SpcWidth

# X,Y,Z ̃{^
BtnWidth=BtnList[BtnList_X][2]+20

# Vertex , RealTime IvṼ{^
DevelopLabelWidth=0
for i in range(len(DevelopLabel)):
  k=Draw.GetStringWidth(DevelopLabel[i])
  if DevelopLabelWidth<k:
    DevelopLabelWidth=k
DevelopLabelWidth+=SpcWidth

# + O̓̓{^
BaseNameBtn=['Src ','Dest']
NameBtnList=[Draw.Create('_Src'),Draw.Create('_Dest')]
NameBtnList_Src=0
NameBtnList_Dest=1

def DrawGui():
    global BtnList,EnableBtnList,ShapeMenu,NameBtnList
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    
    # + Button X,Y,Z
    y-=BaseHeight*2
    s=BtnHeight-2
    for i in [BtnList_X,BtnList_Y,BtnList_Z]:
      EnableBtnList[i]=Draw.Toggle(EnableBtnStr[EnableBtnList[i].val],Event_Enable,x+(s+BtnWidth+10)*i,y+2,s-2,BtnHeight-4,EnableBtnList[i].val)
      if EnableBtnList[i].val==0:
        BtnList[i][0]=Draw.Toggle(DirectionValue[BtnList[i][0].val][0]+BtnList[i][1],Event_XYZ,x+s+(s+BtnWidth+10)*i,y,BtnWidth,BtnHeight,BtnList[i][0].val)
    #   - A^C{^ Normal Ȃs{^`
    i+=1
    MaxWidth=x+(s+BtnWidth+10)*i+20
    if BtnList[BtnList_RealTime][0].val==0:
      Draw.Button (BtnList[BtnList_Execute][1],Event_Execute,MaxWidth,y,BtnList[BtnList_Execute][2]+SpcWidth,BaseHeight,"")
    # Kvʂ̉
    MaxWidth+=BtnList[BtnList_Execute][2]+SpcWidth

    # + Label Option
    y-=BaseHeight
    BGL.glRasterPos2f(x, y)
    Draw.Text(SplitStr)
    
    # + OptionBtn:Develop : Reverse,RealTime
    w=x+(DevelopLabelWidth+4)*2+20
    ww=MaxWidth-w-20-s
    x=20
    y-=4
    for i in [BtnList_Reverse,BtnList_RealTime]:
      k=(i-BtnList_Reverse)  # 0..1
      y-=BaseHeight+6
      BGL.glRasterPos2f(x, y+4)
      Draw.Text(DevelopLabel[DevelopLabel_Vertex+k])
      BtnList[i][0]=Draw.Toggle(DevelopLabel[BtnList[i][0].val*(k+1)],Event_Reverse+k,x+DevelopLabelWidth+4,y,DevelopLabelWidth,BtnHeight,BtnList[i][0].val)
      NameBtnList[k]=Draw.String(BaseNameBtn[k]+' >> ',Event_Name,x+w,y-(BaseHeight+6),ww-4,BtnHeight,NameBtnList[k].val,255)
      Draw.Button ('<',Event_MenuSrc+k,x+w+ww,y-(BaseHeight+6),s,BtnHeight,"")
    # + Shape Menu
    y-=BaseHeight+6
    BGL.glRasterPos2f(x, y+4)
    Draw.Text(DevelopLabel[DevelopLabel_ShapeKey])
    ShapeMenu = Draw.Menu(ShapeMenuStr,Event_Menu,x+DevelopLabelWidth+4,y,DevelopLabelWidth,BtnHeight,ShapeMenu.val)
    
    # + Version
    y-=BaseHeight+6
    x=20
    BGL.glRasterPos2f(MaxWidth-VerWidth, y)
    Draw.Text(Version+Author)
    
    # + Exit Button
    y-=BaseHeight
    Draw.Button (BtnList[BtnList_Exit][1],Event_Exit,x,y,BtnList[BtnList_Exit][2]+SpcWidth,BaseHeight,"")

# Iꂽ_钸_O[vă|bvAbvj[ɕ\B
def SelectPopUpFunction(IsDest):
  global NameBtnList
  
  # + Ȃƒ_񂪍ŐVɂȂȂ
  IsEditMode=0
  if Blender.Window.EditMode() :
    IsEditMode+=1
    Blender.Window.EditMode(0)
  
  try:
    # + IIuWFNg擾
    SelectObject=Blender.Object.GetSelected()[0]
    
    # + IIuWFNg̃f[^猟
    Mesh=SelectObject.getData()
    
    NameList=[]
    for s in Mesh.getVertGroupNames():
      vlist=Mesh.getVertsFromGroup(s)
      for v in vlist:
        if Mesh.verts[v].sel==1 :
	  NameList.append(s)
	  break
    
    # + _̃O[v擾łH
    if len(NameList)==0:
      # - YȂ
      Draw.PupMenu("It doesn't exist.")
    else:
      # - Y |bvAbvj[ŕ\
      i=0
      work=''
      for s in NameList:
	i+=1
	work+='| ' + s + " %x" + str(i)
      #work='test \t'+work@# ^Cg͂ȂĂ炵
      i=Draw.PupMenu(work)
      if i>0:
        NameBtnList[NameBtnList_Src+IsDest].val=NameList[i-1]
  except:
    Draw.PupMenu('SelectPopUpFunction - Error..')
  
  # + ʂ̏Ԃɖ߂
  if IsEditMode :
    Blender.Window.EditMode(1)

# s
def ExecuteFunction():
    # + XYZ ̗LAl擾
    IsEnableX=EnableBtnList[BtnList_X].val
    IsEnableY=EnableBtnList[BtnList_Y].val
    IsEnableZ=EnableBtnList[BtnList_Z].val
    
    # + XYZ SIt ܂͒_O[vɖ͂鎞͉ȂB
    if (IsEnableX+IsEnableY+IsEnableZ)==3: return
    elif (len(NameBtnList[NameBtnList_Src].val)==0) : return
    elif (len(NameBtnList[NameBtnList_Dest].val)==0) : return

    # + ݂̑̏ԂL
    #   - Edit Mode ̏ꍇ Object Mode ɐ؂ւB
    #     ȂƈȑO Edit Mode LĂԂ̏ɃANZX邱ƂɂȂB
    IsEditMode=0
    if Blender.Window.EditMode() :
      Blender.Window.EditMode(0)
      IsEditMode=1
    FRAME=Blender.Get('curframe')
    
    try:
      # + IIuWFNg擾
      SelectObject=Blender.Object.GetSelected()[0]
      
      # + SubSurf ƂgꍇɕKv炵
      SelectObject.makeDisplayList()
      
      # + IIuWFNg̃f[^
      Mesh=SelectObject.getData(mesh=1)
      
      # + ̓{^當擾O[v_Xg擾
      Vertxlist_Src=Mesh.getVertsFromGroup(NameBtnList[NameBtnList_Src].val)   # '_Src'
      Vertxlist_Dest=Mesh.getVertsFromGroup(NameBtnList[NameBtnList_Dest].val) # '_Dest'

      # + Direction  1 or -1
      x=DirectionValue[BtnList[BtnList_X][0].val][1]
      y=DirectionValue[BtnList[BtnList_Y][0].val][1]
      z=DirectionValue[BtnList[BtnList_Z][0].val][1]
      
      # + _W̎W
      # record [ 0:x 1:y 2:z ]
      dat=[]
      for v in Vertxlist_Src:
        dat.append(Mesh.verts[v].co)
      
      # + ϊ
      if BtnList[BtnList_Reverse][0].val:
        # - ~ɓWJ (Mirror ͔]Rs[Ă邩炱H)
        #   Last to
        i=len(dat)-1
        for v in Vertxlist_Dest:
          if IsEnableX==0 : Mesh.verts[v].co[0]=x*dat[i][0]
          if IsEnableY==0 : Mesh.verts[v].co[1]=y*dat[i][1]
          if IsEnableZ==0 : Mesh.verts[v].co[2]=z*dat[i][2]
          print "%3d  : ( % .3f , % .3f , % .3f )" % (Mesh.verts[v].index, Mesh.verts[v].co[0],Mesh.verts[v].co[1],Mesh.verts[v].co[2] )
          i-=1
      else:
        # - ɓWJ First to
        i=0
        for v in Vertxlist_Dest:
          if IsEnableX==0 : Mesh.verts[v].co[0]=x*dat[i][0]
          if IsEnableY==0 : Mesh.verts[v].co[1]=y*dat[i][1]
          if IsEnableZ==0 : Mesh.verts[v].co[2]=z*dat[i][2]
          print "%3d  : ( % .3f , % .3f , % .3f )" % (Mesh.verts[v].index, Mesh.verts[v].co[0],Mesh.verts[v].co[1],Mesh.verts[v].co[2] )
          i+=1
      # Ńf[^XV
      Mesh.update()
      
      # + VFCvL[  None=1  Make=2  Ask=3
      if not(ShapeMenu.val==1):
        IsShape=1
        if ShapeMenu.val==3:
          IsShape=Draw.PupMenu("Do you want to Add Shape Key ? %t| YES %x1| NO ? %x2 ")
	if IsShape==1:
          Mesh.insertKey(FRAME,'relative')
        Mesh.update()
      
      Blender.Redraw()
    except:
      Draw.PupMenu('Error..')
    
    # + ʂ̏Ԃɖ߂
    if IsEditMode :
      Blender.Window.EditMode(1)

# {^Cxg
def ButtonEvent(evt):
    if evt in [Event_XYZ,Event_Reverse]:
        Draw.Register(DrawGui, KeyEvent, ButtonEvent)
	if BtnList[BtnList_RealTime][0].val==1:
	   ExecuteFunction()
    elif evt in [Event_MenuSrc,Event_MenuDest]	: SelectPopUpFunction(evt==Event_MenuDest)
    elif (evt in [Event_Enable,Event_RealTime])	: Draw.Register(DrawGui, KeyEvent, ButtonEvent)
    elif (evt==Event_Execute)			: ExecuteFunction()
    elif (evt==Event_Exit)			: Draw.Exit()

# L[Cxg
def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :
        return
    if evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
